var current_verse = null;

var biblicalRef = /(\w+)\.([^.]+)\.(\d+)/;

function dragBarHMouseDown(e) {
    e.preventDefault();
    window.addEventListener("mousemove", windowMouseMoveH, false);
}

function windowMouseMoveH(e) {
	//TODO: 100 needs to be dynamic based on header height?
    document.getElementById("overtext_div").style.height = e.pageY - 100 + 2 + "px";
}

function windowMouseUp(e) {
    window.removeEventListener("mousemove", windowMouseMoveH, false);
}

function initialise() {
	document.getElementById("hdrag").addEventListener("mousedown", dragBarHMouseDown, false);
	window.addEventListener("mouseup", windowMouseUp, false);
	setup();
}

function loadXMLDoc(dname) {
	if (window.XMLHttpRequest) {
  		xhttp=new XMLHttpRequest();
  	}
	else {
  		xhttp=new ActiveXObject("Microsoft.XMLHTTP");
  	}
	xhttp.open("GET",dname,false);
	xhttp.send("");
	return xhttp.responseXML;
}

function setup(){
	var xml, xsl;
	xml = loadXMLDoc('basetext.xml');
	xsl = loadXMLDoc("basetextxsl.xml");
	display_overtext(xsl, xml);
}

function display_overtext(xsl, xml) {
	// code for IE
	
	if (window.ActiveXObject) {
		ex=xml.transformNode(xsl);
		document.getElementById("overtext_div").innerHTML=ex;
	} else {
		xsltProcessor = new XSLTProcessor();
  		xsltProcessor.importStylesheet(xsl);
  		resultDocument = xsltProcessor.transformToFragment(xml,document);
  		wrapper = document.getElementById("overtext_div");
  		console.log(wrapper);
  		wrapper.innerHTML = ''
  		wrapper.appendChild(resultDocument);
	}
}

function gotoApparatus(apparatus) {
	window.parent.location.href = '' + apparatus;
	return false;
}

function clearDisplay() {
	var abs, i;
	abs = document.getElementsByClassName('verse');
 	for (i = 0; i < abs.length; i += 1) {
 		abs[i].style.display='none';
 	}
}

//function resetforms() {
	//document.getElementById("chapterverse").reset();
//}

function change_select(id, select) {
	var select;
	select = document.getElementById(select);
	for (i = 0; i < select.length; i += 1) {
		if (select.options[i].value === String(id)) {
			select.value = id;			
			return true;
		}
	}
	return false;
}


function getVerse(direction) {
	var verse, newverse, i, verseMenu, found, chapter, original_verse, match;
	original_verse = current_verse;	
	if (current_verse !== null) {
		match = biblicalRef.exec(current_verse);
		verse = parseInt(match[3]);
		if (direction === 'next') {
			newverse = verse + 1;
			current_verse = match[1] + '.' + match[2] + '.' + newverse;
			found = change_select(current_verse, 'verseMenu');
			if (found === true) {
				gotoVerse(current_verse);
			} else {
				chapter = parseInt(match[2]);
				newchapter = chapter + 1;
				found = change_select(newchapter, 'chapterMenu');
				if (found === true) {
					loadVerses(newchapter);
					current_verse = match[1] + '.' + newchapter + '.1';
					found = change_select(current_verse, 'verseMenu');
					if (found === true) {
						gotoVerse(current_verse);
					} else {
						current_verse = original_verse;
					}
				} else {
					current_verse = original_verse;
				}			
			}
		} else {
			newverse = verse - 1;
			current_verse = match[1] + '.' + match[2] + '.' + newverse;
			found = change_select(current_verse, 'verseMenu');
			if (found === true) {
				gotoVerse(current_verse);
			} else {
				chapter = parseInt(match[2]);
				newchapter = chapter - 1;
				found = change_select(newchapter, 'chapterMenu');
				if (found === true) {
					loadVerses(newchapter);
					document.getElementById('verseMenu').selectedIndex= document.getElementById('verseMenu').length-1;
					gotoVerse(document.getElementById('verseMenu').value);
				} else {
					current_verse = original_verse;
				}
			}
		}
	}
}

function gotoVerse(verseID){
	clearDisplay();
	document.getElementById(verseID).style.display = "block"; 
	current_verse = verseID;
	console.log(verseID);
	showAppWhole(verseID + '-APP');
}

function showAppWhole(AppID){
	var xml, xsl, chapter, match;
	match = biblicalRef.exec(AppID);
	chapter = match[2];
	console.log(chapter);
	xmlapp = loadXMLDoc('Mark_chapter_' + chapter + '.xml');
	xslapp = loadXMLDoc("apparatusxsl.xml");
	// code for IE
	//TODO: needs parameter added
	if (window.ActiveXObject) {
  		ex=xml.transformNode(xsl);
  		document.getElementById("app_wrapper").innerHTML=ex;
  	}
	// code for Mozilla, Firefox, Opera, etc.
	else {
  		xsltProcessor=new XSLTProcessor();
  		xsltProcessor.importStylesheet(xslapp);
  		xsltProcessor.setParameter(null, 'verse', AppID);
  		resultDocument = xsltProcessor.transformToFragment(xmlapp,document);
  		wrapper = document.getElementById("app_wrapper");
  		wrapper.innerHTML = '';
  		wrapper.appendChild(resultDocument);
  	}
}

function loadVerses(chapter){
	var abs, verseoptions, id, i, versenumber, verseMenu, match;
	clearDisplay();
 	abs = document.getElementsByClassName("verse");
 	verseoptions = '<option value="">Verse</option>';
 	for (i = 0; i < abs.length; i += 1){
	  	id = abs[i].getAttribute("id");
	  	console.log(id);
	   	if (id.search("\\." + chapter + "\\.") !== -1) {
	   		match = biblicalRef.exec(id);
			versenumber = match[3];
	        verseoptions += '<option value="' + id + '">' + versenumber + '</option>';
	   	}
 	}
 	verseMenu = document.getElementById("verseMenu");
 	verseMenu.innerHTML = verseoptions;
}

function gotoTranscription(wit, verse) {
    var hash, url, transcription_window;
    if (wit[0] === 'K') {
    	wit = wit.substring(1);
    }
    if (/^[PL][0-9]+S?[0-9]?(.*)/.test(wit)) {
        hand = /^[PL][0-9]+S?[0-9]?(.*)/.exec(wit)[1]
        wit = wit.replace(hand, '')
    } else if (/^01([^0-9].*)?/.test(wit)) {
        hand = /^01([^0-9].*)?/.exec(wit)[1]
        wit = wit.replace(hand, '')
    } else if (/^05S?([^0-9].*)?/.test(wit)) {
        hand = /^05S?([^0-9].*)?/.exec(wit)[1]
        wit = wit.replace(hand, '')
    } else if (/^[0-9]+S?([^0-9].*)?/.test(wit)) {
        hand = /^[0-9]+S?([^0-9].*)?/.exec(wit)[1]
        wit = wit.replace(hand, '')
    }
    
    // url = wit;
    url = '../transcriptions/02_' + wit + '.xml';
	// url = 'http://www.epistulae.org/transcriptions/index.html?witness=' + wit + '&language=greek';
	if (typeof verse !== 'undefined') {
	   hash = '#V-' + current_verse;
	   url = url + hash;
	}
	transcription_window = window.open(url,'IGNTPxml','width=900,height=800,toolbar=yes, location=yes,directories=no,status=yes,menubar=yes,scrollbars=yes, resizable=yes,copyhistory=yes','');	
	transcription_window.focus();
	
	
	
	//To open it in the transcription frame: window.open(''+ wit,'transcription','','') ;
	//To open it in a new window: window.open(''+ wit,'IGNTPxml','width=900,height=800,toolbar=yes, location=yes,directories=no,status=no,menubar=yes,scrollbars=yes, resizable=yes,copyhistory=yes','') ;
	return false;
}

